define("scarabWinManagerApi", ["componentmodelComponentApi", "gameLayoutApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, gameLayoutApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof scarabWinManagerApi == 'undefined') {
            var scarabWinManagerApi = {};
        };
        scarabWinManagerApi.WinManagerDeclaration = function() {};
        scarabWinManagerApi.WinManagerDeclaration = ck_implements(scarabWinManagerApi.WinManagerDeclaration, componentmodelComponentApi.IComponentDeclaration);
        scarabWinManagerApi.WinManagerDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        scarabWinManagerApi.WinManagerDeclaration.__name__ = ["scarabWinManagerApi", "WinManagerDeclaration"];
        scarabWinManagerApi.WinManagerDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        scarabWinManagerApi.WinManagerDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        scarabWinManagerApi.WinManagerDeclaration.prototype.getImplementedPorts = function() {
            return [scarabWinManagerApi.IWinManagerImplementationPort];
        };
        scarabWinManagerApi.WinManagerDeclaration.prototype.getUsedPorts = function() {
            return [scarabWinManagerApi.IWinManagerPort, gameLayoutApi.IGameLayoutPort];
        };
        scarabWinManagerApi.WinManagerDeclaration.prototype.__class__ = scarabWinManagerApi.WinManagerDeclaration;

        scarabWinManagerApi.IWinManagerImplementationPort = function() {}
        scarabWinManagerApi.IWinManagerImplementationPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        scarabWinManagerApi.IWinManagerPort = function() {}
        scarabWinManagerApi.IWinManagerPort.prototype = {

            getShow: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getHide: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        scarabWinManagerApi.WinManagerPort = function(bus) {
            this.hide = new clientkernelEventbusApi.Topic("winmanager:hide");
            this.show = new clientkernelEventbusApi.Topic("winmanager:show");
            this.show.connect(bus);
            this.hide.connect(bus);
        };
        scarabWinManagerApi.WinManagerPort = ck_implements(scarabWinManagerApi.WinManagerPort, scarabWinManagerApi.IWinManagerPort);
        scarabWinManagerApi.WinManagerPort = ck_implements(scarabWinManagerApi.WinManagerPort, scarabWinManagerApi.IWinManagerImplementationPort);
        scarabWinManagerApi.WinManagerPort.__interfaces__ = [scarabWinManagerApi.IWinManagerPort, scarabWinManagerApi.IWinManagerImplementationPort];
        scarabWinManagerApi.WinManagerPort.__name__ = ["scarabWinManagerApi", "WinManagerPort"];
        scarabWinManagerApi.WinManagerPort.prototype.show = null;
        scarabWinManagerApi.WinManagerPort.prototype.hide = null;
        scarabWinManagerApi.WinManagerPort.prototype.getShow = function() {
            return this.show;
        };
        scarabWinManagerApi.WinManagerPort.prototype.getHide = function() {
            return this.hide;
        };
        scarabWinManagerApi.WinManagerPort.prototype.__class__ = scarabWinManagerApi.WinManagerPort;
        scarabWinManagerApi.WinManagerPortFactory = function() {};
        scarabWinManagerApi.WinManagerPortFactory = ck_implements(scarabWinManagerApi.WinManagerPortFactory, componentmodelComponentApi.IPortFactory);
        scarabWinManagerApi.WinManagerPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        scarabWinManagerApi.WinManagerPortFactory.__name__ = ["scarabWinManagerApi", "WinManagerPortFactory"];
        scarabWinManagerApi.WinManagerPortFactory.prototype.provide = function(channel) {
            return new scarabWinManagerApi.WinManagerPort(channel);
        };
        scarabWinManagerApi.WinManagerPortFactory.prototype["use"] = function(channel) {
            return new scarabWinManagerApi.WinManagerPort(channel);
        };
        scarabWinManagerApi.WinManagerPortFactory.prototype.__class__ = scarabWinManagerApi.WinManagerPortFactory;
        scarabWinManagerApi.WinManagerShowPayload = function(type, content, state) {
            this.type = type;
            this.state = state;
            this.content = content;
        };
        scarabWinManagerApi.WinManagerShowPayload.__name__ = ["scarabWinManagerApi", "WinManagerShowPayload"];
        scarabWinManagerApi.WinManagerShowPayload.prototype.type = null;
        scarabWinManagerApi.WinManagerShowPayload.prototype.content = null;
        scarabWinManagerApi.WinManagerShowPayload.prototype.state = null;
        scarabWinManagerApi.WinManagerShowPayload.prototype.__class__ = scarabWinManagerApi.WinManagerShowPayload;
        scarabWinManagerApi.WinManagerTypeEnum = {
            __ename__: ["scarabWinManagerApi", "WinManagerTypeEnum"],
            __constructs__: ["wm_win_frames"]
        };
        scarabWinManagerApi.WinManagerTypeEnum.wm_win_frames = ["wm_win_frames", 0];
        scarabWinManagerApi.WinManagerTypeEnum.wm_win_frames.toString = $estr;
        scarabWinManagerApi.WinManagerTypeEnum.wm_win_frames.__enum__ = scarabWinManagerApi.WinManagerTypeEnum;
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        return {
            exports: scarabWinManagerApi
        };
    });
//# sourceURL=scarabWinManagerApi.js